from bs4 import BeautifulSoup
from py_mini_racer import py_mini_racer
import os
import zipfile

ctx = py_mini_racer.MiniRacer()

# load csp evaluator
with open('evaluator_binary.js') as f:
     cf_js = f.read()
ctx.eval(cf_js)

nr_htm_files = 0
nr_csps_found = 0

for entry in os.scandir("../APKs"):
     if os.fsdecode(entry).endswith(".apk"): 
         print("Evaluating ", os.fsdecode(entry))
         with zipfile.ZipFile(entry, 'r') as thezip:
                for zipinfo in thezip.infolist():
                    with thezip.open(zipinfo) as thefile:
                        if "assets" and ".htm" in zipinfo.filename:
                            #print(zipinfo.filename, thefile)
                            nr_htm_files += 1
                            page = thefile.read()
                            soup = BeautifulSoup(page, features="lxml")
                            for tag in soup.find_all("meta"):
                                if tag.get("http-equiv", None) == "Content-Security-Policy":
                                    nr_csps_found += 1
                                    csp = tag.get("content", None)
                                    ctx.eval("var parsedCsp = \"" + csp + "\";")
                                    ctx.eval("var parser = new csp.CspParser(parsedCsp);")
                                    ctx.eval("var evaluator = new csp.CspEvaluator(parser.csp, csp.Version.CSP3);")
                                    ctx.eval("var findings = evaluator.evaluate();")
                                    findings = ctx.eval("findings")
                                    print(findings)
                        
print("HTM files analysed:" , str(nr_htm_files), "of which have a CSP defined:",  str(nr_csps_found))
exit(0)

with open('index.html', 'r') as myfile:
  page = myfile.read()

soup = BeautifulSoup(page, features="lxml")
for tag in soup.find_all("meta"):
    if tag.get("http-equiv", None) == "Content-Security-Policy":
        csp = tag.get("content", None)
        ctx.eval("var parsedCsp = \"" + csp + "\";")
        ctx.eval("var parser = new csp.CspParser(parsedCsp);")
        ctx.eval("var evaluator = new csp.CspEvaluator(parser.csp, csp.Version.CSP3);")
        ctx.eval("var findings = evaluator.evaluate();")
        findings = ctx.eval("findings")
        print(findings)
        
